;(function(){

	window._w.configview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.configview.ti = _t[template];
			_w.configview.setConfigViewFormMeta();
			_w.configview.ti.hydrate(_w.configview.formMeta);

			// Retrieve initial view data.
			_w.configview.itemId = 1;
			_w.configview.ownAccount = (App.userData.id == _w.configview.itemId)
				? true
				: false;
			App.API.getTask(
				'updateConfig:' + _w.configview.itemId, 'AppConfig', 'Config.Update', _w.configview.itemId,
				{'id':_w.configview.itemId}, $.proxy( _w.configview._onConfigViewDataReceived, this ), _w.taskContractError
			);
		},

		onTemplatePublished : function( template, event, eventData )
		{
			if (null != _w.configview.itemData)
			{
				_w.configview._setupValidation();
			}
		},

		setConfigViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.configview.formMeta = {
				'sourceEmailAddress' : {
					type  : 'input',
					id    : 'sourceEmailAddress',
					title : 'Source email address',
					value : data.sourceEmailAddress ? data.sourceEmailAddress : '',
					maxlength : 250
				},
				'sourceMobileAddress' : {
					type  : 'mobile',
					id    : 'sourceMobileAddress',
					title : 'Source mobile address',
					value : data.sourceMobileAddress ? data.sourceMobileAddress : '',
					maxlength : 20
				},
				'adminEmailAddress' : {
					type  : 'input',
					id    : 'adminEmailAddress',
					title : 'Administrative email address',
					value : data.adminEmailAddress ? data.adminEmailAddress : '',
					maxlength : 250
				},
				'priceGuideOpenDays' : {
					type  : 'input',
					id    : 'priceGuideOpenDays',
					title : 'Open Hours',
					value : data.priceGuideOpenDays ? data.priceGuideOpenDays : '',
					maxlength : 2
				},
				'priceGuideCompletionDays' : {
					type  : 'input',
					id    : 'priceGuideCompletionDays',
					title : 'Completion days',
					value : data.priceGuideCompletionDays ? data.priceGuideCompletionDays : '',
					maxlength : 2
				},
				'auctionMaxDays' : {
					type  : 'input',
					id    : 'auctionMaxDays',
					title : 'Auction max days',
					value : data.auctionMaxDays ? data.auctionMaxDays : '',
							maxlength : 2
				}
			};
		},

		_onConfigViewDataReceived : function( response )
		{
			_w.configview.itemData = response.Data;
			_w.configview.setConfigViewFormMeta(response.Data);
			_w.configview.ti.hydrate(_w.configview.formMeta);
			if (_w.configview.ti.published)
			{
				_w.configview._setupValidation();
			}
		},

		_setupValidation : function ()
		{
			$('#frmConfigView').validate({
				"rules": {
					priceGuideOpenDays: {required: true, minlength: 1, maxlength: 2, digits: true},
					priceGuideCompletionDays: {required: true, minlength: 1, maxlength: 2, digits: true},
					auctionMaxDays: {required: true, minlength: 1, maxlength: 2, digits: true},
					sourceMobileAddress: {required: false, mobile: true},
					sourceEmailAddress: {required: true, email: true},
					adminEmailAddress: {required: true, email: true}
				},
				messages: {
					sourceEmailAddress: {
						email: "Must be a valid email address."
					},
					adminEmailAddress: {
						email: "Must be a valid email address."
					},
					priceGuideOpenDays: {
						minlength: "Must be 1 to 2 digit.",
						maxlength: "Must be 1 to 2 digit."
					},
					priceGuideCompletionDays: {
						minlength: "Must be 1 to 2 digits.",
						maxlength: "Must be 1 to 2 digits."
					},
					auctionMaxDays: {
						minlength: "Must be 1 to 2 digits.",
						maxlength: "Must be 1 to 2 digits."
					}
				},
				submitHandler: function( form ) {
					$('#btnUpdate').prop('disabled', true);
					var data = _w.configview._prepConfigUpdateData();
					App.API.execTask(
							'updateConfig:' + _w.configview.itemId, data, {},
							_w.configview._onConfigUpdated, _w.taskExecError
						);
				}
			});
			$('#btnUpdate').prop('disabled', false);
		},

		_prepConfigUpdateData : function()
		{
			var data = {Config:_w.configview.ti.harvest()};
			if ('' == data.Config.sourceMobileAddress)
			{
				data.Config.sourceMobileAddress = null;
			}
			return data;
		},

		_onConfigUpdated : function( response )
		{
			window.location.hash = '/systemsettings';
		}

	};

})();