;(function(){

	window._w.damages = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.damages.ti = _t[template];

			_w.damages.initGrid();

			// Damage grid
			if (null == App.API.taskContract('gridDamage'))
			{
				App.API.getTask(
						'gridDamage', 'Stock', 'Damage.List', null,
						{}, _w.damages.loadDamageGrid, _w.taskContractError
						);
			}
			else
			{
				_w.damages.loadDamageGrid( null, {}, {} );
			}
			if (null == App.API.taskContract('addDamage'))
			{
				App.API.getTask(
						'addDamage', 'Stock', 'Damage.Create', null,
						{}, function () {}, _w.taskContractError
						);
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			_w.damages.ti.hydrateParam('name', {
				type  : 'input',
				id    : 'name',
				title : 'Damage',
				value : ''
			});
			_w.damages._setupValidation();
		},

		initGrid : function()
		{

			_w.damages.ti.hydrate({
				// Damage grid
				'gridDamageTitle': 'Manage damages',
				'gridDamageColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						Damage: {
							id: 'gridDamageColumn_Damage',
							title: 'COMPONENT'
						}
					}
				},
				'gridDamageRowRepeater': {},
				'name' : {
					type  : 'input',
					id    : 'name',
					title : 'Damage',
					value : ''
				}
			});

		},

		loadDamageGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridDamage', data, options,
					_w.damages._onDamageGridDataReceived, _w.taskExecError
					);
		},

		_onDamageGridDataReceived : function( response )
		{
			_w.damages.ti.hydrateParam('gridDamageRowRepeater', {});
			var gridData = [];
			for (var i = 0; i < response.Data.length; i++)
			{
				var row = response.Data[i];
				gridData.push({
					items: {
						'id'   : row.id,
						'Damage' : row.name ? row.name : ''
					}
				});
			}
			_w.damages.ti.hydrateParam('gridDamageRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
		},

		_setupValidation : function ()
		{
			$('#frmDamageView').validate({
				"rules": {
					name: "required"
				},
				messages: {
					name : "This field is required."
				},
				submitHandler: function( form ) {
					$('#btnSave').prop('disabled', true);
					var data = { Damage: { name: $('#name').val() } };
					App.API.execTask(
							'addDamage', data, {},
							function() {
								$('#name').val('');
								_w.damages.loadDamageGrid( null, {}, {} );
								$('#btnSave').prop('disabled', false);
							}, _w.taskExecError
						);
				}
			});
			$('#btnSave').prop('disabled', false);
		}

	};

})();