;
(function () {

  window._w.regionalmanager = {
    ti: null,
    itemId: null,
    onTemplateReady: function (template, event, eventData)
    {
      _w.regionalmanager.ti = _t[template];

      _w.regionalmanager.initGrid();

      App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');

      // RegionalManager grid
      if (null == App.API.taskContract('gridRegionalManager'))
      {
        App.API.getTask(
                'gridRegionalManager', 'AppConfig', 'RegionalManager.List', null,
                {}, _w.regionalmanager.loadRegionalManagerGrid, _w.taskContractError
                );
      }
      else
      {
        _w.regionalmanager.loadRegionalManagerGrid(null, {}, {});
      }
      if (null == App.API.taskContract('addRegionalManager'))
      {
        App.API.getTask(
                'addRegionalManager', 'AppConfig', 'RegionalManager.Create', null,
                {}, function () {
        }, _w.taskContractError
                );
      }
    },
    onTemplatePublished: function (template, event, eventData)
    {
      _w.regionalmanager.ti.hydrateParam('group', {
        type: 'select',
        id: 'group',
        title: 'Group',
        dataStoreId: 'groups',
        value: '',
      });
      _w.regionalmanager.ti.hydrateParam('firstName', {
        type: 'input',
        id: 'firstName',
        title: 'Name',
        value: ''
      });
      _w.regionalmanager.ti.hydrateParam('familyName', {
        type: 'input',
        id: 'familyName',
        title: 'Surame',
        value: ''
      });
      _w.regionalmanager.ti.hydrateParam('email', {
        type: 'input',
        id: 'email',
        title: 'Email',
        value: ''
      });
      _w.regionalmanager.ti.hydrateParam('mobile', {
        type: 'mobile',
        id: 'mobile',
        title: 'Mobile',
        value: ''
      });
      _w.regionalmanager._setupValidation();
      $('#btnNew').click(function () {
        _w.regionalmanager.itemId = null;
        $('#group').selectpicker('val', '');
        $('#firstName').val('');
        $('#familyName').val('');
        $('#email').val('');
        $('#mobile').val('');
        $('#btnSave').html(' Add ');
      });
    },
    initGrid: function ()
    {

      _w.regionalmanager.ti.hydrate({
        // RegionalManager grid
        'gridRegionalManagerTitle': 'Manage Regional Manager',
        'gridRegionalManagerColumnHeaders': {
          constructor: 'GridColumnHeader',
          items: {
            firstName: {
              id: 'gridRegionalManagerColumn_firstName',
              title: 'NAME'
            },
            familyName: {
              id: 'gridRegionalManagerColumn_familyName',
              title: 'SURNAME'
            },
            email: {
              id: 'gridRegionalManagerColumn_email',
              title: 'EMAIL'
            },
            mobile: {
              id: 'gridRegionalManagerColumn_mobile',
              title: 'MOBILE'
            },
            groupName: {
              id: 'gridRegionalManagerColumn_groupName',
              title: 'GROUP'
            }
          }
        },
        'gridRegionalManagerRowRepeater': {}
      });

    },
    loadRegionalManagerGrid: function (contract, data, options)
    {
      App.API.execTask(
              'gridRegionalManager', data, options,
              _w.regionalmanager._onRegionalManagerGridDataReceived, _w.taskExecError
              );
    },
    _onRegionalManagerGridDataReceived: function (response)
    {
      _w.regionalmanager.ti.hydrateParam('gridRegionalManagerRowRepeater', {});
      var gridData = [];
      for (var i = 0; i < response.Data.length; i++)
      {
        var row = response.Data[i];
        gridData.push({
          rowId: row.id,
          group: row.group.id,
          onClick: function (meta) {
            _w.regionalmanager.itemId = meta.rowId;
            $('#group').selectpicker('val', meta.group);
            $('#firstName').val(meta.items.firstName);
            $('#familyName').val(meta.items.familyName);
            $('#email').val(meta.items.email);
            $('#mobile').val(meta.items.mobile);
            $('#btnSave').html(' Update ');
          },
          items: {
            'id': row.id,
            'firstName': row.firstName ? row.firstName : '',
            'familyName': row.familyName ? row.familyName : '',
            'email': row.email ? row.email : '',
            'mobile': row.mobile ? row.mobile : '',
            'groupName': row.group.name ? row.group.name : '',
          }
        });
      }
      _w.regionalmanager.ti.hydrateParam('gridRegionalManagerRowRepeater', {
        constructor: 'GridDataRow',
        items: gridData
      });
    },
    _setupValidation: function ()
    {
      $('#frmRegionalManagerView').validate({
        "rules": {
          group: "required",
          firstName: "required",
          familyName: "required",
          mobile: {required: true, mobile: true},
          email: {required: true, email: true},
        },
        messages: {
          group: "This field is required.",
          firstName: "This field is required.",
          familyName: "This field is required.",
          mobile: "This field is required.",
          email: {
            email: "Must be a valid email address."
          }
        },
        submitHandler: function (form) {
          $('#btnSave').prop('disabled', true);
          var data = {
            RegionalManager: {
              group: $('#group').val(),
              firstName: $('#firstName').val(),
              familyName: $('#familyName').val(),
              email: $('#email').val(),
              mobile: $('#mobile').val()
            }
          };
          if (null == _w.regionalmanager.itemId)
          {
            App.API.execTask(
                    'addRegionalManager', data, {},
                    function () {
                      $('#group').selectpicker('val', '');
                      $('#firstName').val('');
                      $('#familyName').val('');
                      $('#email').val('');
                      $('#mobile').val('');
                      _w.regionalmanager.loadRegionalManagerGrid(null, {}, {});
                      $('#btnSave').prop('disabled', false);
                      $('#btnSave').html(' Add ');
                    }, _w.taskExecError
                    );
          }
          else
          {
            App.API.getTask(
                    'updateRegionalManager' + _w.regionalmanager.itemId, 'AppConfig', 'RegionalManager.Update', null,
                    {id: _w.regionalmanager.itemId}, function () {
              App.API.execTask(
                      'updateRegionalManager' + _w.regionalmanager.itemId, data, {},
                      function () {
                        $('#group').selectpicker('val', '');
                        $('#firstName').val('');
                        $('#familyName').val('');
                        $('#email').val('');
                        $('#mobile').val('');
                        _w.regionalmanager.loadRegionalManagerGrid(null, {}, {});
                        $('#btnSave').prop('disabled', false);
                        $('#btnSave').html(' Add ');
                      }, _w.taskExecError
                      );
            }, _w.taskContractError
                    );
          }
        }
      });
      $('#btnSave').prop('disabled', false);
    }

  };

})();