;
(function () {

	window._w.systemxmlrpcclientview = {
		itemId: null,
		itemData: null,
		formMeta: null,
		ti: null,
		limited: false,
		newItem: false,
		ownAccount: true,
		onTemplateReady: function (template, event, eventData)
		{
			_w.systemxmlrpcclientview.itemData = null;
			_w.systemxmlrpcclientview.ti = _t[template];
			_w.systemxmlrpcclientview.limited = false;

			_w.systemxmlrpcclientview.setXmlRpcViewFormMeta();
			_w.systemxmlrpcclientview.ti.hydrate(_w.systemxmlrpcclientview.formMeta);

			// Retrieve initial view data.
			_w.systemxmlrpcclientview.itemId = App.Util.getUrlParam('id');
			_w.systemxmlrpcclientview.newItem = 0 == _w.systemxmlrpcclientview.itemId;
			if (_w.systemxmlrpcclientview.newItem)
			{
				App.API.getTask(
						'createXmlRpc', 'Valuation', 'XmlRpc.Create', null,
						{}, function(){}, _w.taskContractError
					);
			}
			else
			{
				App.API.getTask(
							'updateXmlRpc:' + _w.systemxmlrpcclientview.itemId, 'Valuation', 'XmlRpc.Update', null,
							{'id': _w.systemxmlrpcclientview.itemId}, $.proxy(_w.systemxmlrpcclientview._onXmlRpcViewDataReceived, this), _w.taskContractError
						);
			}
		},
		onTemplatePublished: function (template, event, eventData)
		{
			if (null != _w.systemxmlrpcclientview.itemData
					|| _w.systemxmlrpcclientview.newItem)
			{
				_w.systemxmlrpcclientview._setupValidation();
			}
		},
		setXmlRpcViewFormMeta: function (data)
		{
			if (!data)
			{
				data = {};
			}
			_w.systemxmlrpcclientview.formMeta = {
				'clientName': {
					type: 'input',
					id: 'clientName',
					title: 'Client name',
					value: data.clientName
				},
				'apiPassword': {
					type: 'input',
					id: 'apiPassword',
					title: 'API password',
					value: ''
				},
				'callbackUrl': {
					type: 'input',
					id: 'callbackUrl',
					title: 'Callback URL',
					value: data.callbackUrl
				},
				'triggerSentToSales': {
					type: 'checkbox',
					id: 'triggerSentToSales',
					title: 'Send to sales callback',
					value: data.triggerSentToSales
				}
			};
		},

		_onXmlRpcViewDataReceived: function (response)
		{
			_w.systemxmlrpcclientview.itemId = response.Data.id;
			_w.systemxmlrpcclientview.itemData = response.Data;
			_w.systemxmlrpcclientview.setXmlRpcViewFormMeta(response.Data);
			_w.systemxmlrpcclientview.ti.hydrate(_w.systemxmlrpcclientview.formMeta);
			if (_w.systemxmlrpcclientview.ti.published)
			{
				_w.systemxmlrpcclientview._setupValidation();
			}
		},

		_setupValidation: function ()
		{
			var rules = {
					'clientName': {required: true},
					'callbackUrl': {required: true}
				};
			if (_w.systemxmlrpcclientview.newItem)
			{
				rules.apiPassword = {required: true}
			}
			$('#frmXmlRpcView').validate({
				rules: rules,
				messages: {
					'clientName': "This field is required.",
					'callbackUrl': "This field is required."
				},
				submitHandler: function (form) {
					$('#btnUpdate').prop('disabled', true);
					$('.dbtn').prop('disabled', true);
					var data = _w.systemxmlrpcclientview._prepXmlRpcUpdateData();
					if (_w.systemxmlrpcclientview.newItem)
					{
						App.API.execTask(
								'createXmlRpc', data, {},
								_w.systemxmlrpcclientview._onXmlRpcUpdated, _w.taskExecError
							);
					}
					else
					{
						App.API.execTask(
									'updateXmlRpc:' + _w.systemxmlrpcclientview.itemId, data, {},
									_w.systemxmlrpcclientview._onXmlRpcUpdated, _w.taskExecError
								);
					}
				}
			});
			$('#btnUpdate').prop('disabled', false);
			if (!_w.systemxmlrpcclientview.newItem)
			{
				if (_w.systemxmlrpcclientview.itemData.archived)
				{
					$('#btnActivate').show();
				}
				else
				{
					$('#btnArchive').show();
				}
				$('#btnActivate').click(function () {
					if (!$('#frmXmlRpcView').valid())
					{
						alert('Please fill in all required fields.');
						return;
					}
					$('#btnUpdate').prop('disabled', true);
					$('.dbtn').prop('disabled', true);
					var data = _w.systemxmlrpcclientview._prepXmlRpcUpdateData();

					App.API.execTask(
							'updateXmlRpc:' + _w.systemxmlrpcclientview.itemId, data, {},
							function () {
								App.API.getTask(
										'unDeleteXmlRpc:' + _w.systemxmlrpcclientview.itemId, 'Valuation', 'XmlRpc.UnDelete', null,
										{'id': _w.systemxmlrpcclientview.itemId},
										$.proxy(function()
										{
											App.API.execTask(
													'unDeleteXmlRpc:' + _w.systemxmlrpcclientview.itemId, data, {},
													_w.systemxmlrpcclientview._onXmlRpcUpdated, _w.taskExecError
												);
										}, this),
										_w.taskContractError
									);
							}, _w.taskExecError
						);
				});
				$('#btnArchive').click(function () {
					if (!$('#frmXmlRpcView').valid())
					{
						alert('Please fill in all required fields.');
						return;
					}
					$('#btnUpdate').prop('disabled', true);
					var data = _w.systemxmlrpcclientview._prepXmlRpcUpdateData();

					App.API.execTask(
							'updateXmlRpc:' + _w.systemxmlrpcclientview.itemId, data, {},
							function () {
								App.API.getTask(
										'deleteXmlRpc:' + _w.systemxmlrpcclientview.itemId, 'Valuation', 'XmlRpc.Delete', null,
										{'id': _w.systemxmlrpcclientview.itemId},
										$.proxy(function()
										{
											App.API.execTask(
													'deleteXmlRpc:' + _w.systemxmlrpcclientview.itemId, data, {},
													_w.systemxmlrpcclientview._onXmlRpcUpdated, _w.taskExecError
												);
										}, this),
										_w.taskContractError
									);
							}, _w.taskExecError
						);
				});
			}
		},

		_prepXmlRpcUpdateData: function ()
		{
			var data = _w.systemxmlrpcclientview.ti.harvest();
			if (null != data.apiPassword && '' != data.apiPassword)
			{
				data.password = data.apiPassword;
			}
			delete data.apiPassword;
			var postData = {XmlRpc: data};
			return postData;
		},

		_onXmlRpcUpdated: function (response)
		{
			window.location.hash = '/xmlrpcclients';
		}

	};

})();