;(function(){

	window._w.xmlrpcrequestlog = {

		ti : null,

		onTemplateReady : function( template, event, eventData )
		{
			_w.xmlrpcrequestlog.ti = _t[template];

			_w.xmlrpcrequestlog.initGrids();

			// XmlRpc grid
			if (null == App.API.taskContract('gridSystemXmlRpcRequest'))
			{
				App.API.getTask(
						'gridSystemXmlRpcRequest', 'Valuation', 'XmlRpcRequestLog.Grid', null,
						{}, _w.xmlrpcrequestlog.loadXmlRpcGrid, _w.taskContractError
						);
			}
			else
			{
				_w.xmlrpcrequestlog.loadXmlRpcGrid( null, {}, {} );
			}
		},

		onTemplatePublished : function( template, event, eventData )
		{
			$(".gridXmlRpcFilter").keypress(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode  == 13) { //Enter key's keycode
					$('#btnXmlRpcSearch').click();
				}
			});

			_w.xmlrpcrequestlog.ti = _t[template];

			// XmlRpc grid
            $('#btnXmlRpcClearSearch').click(_w.xmlrpcrequestlog.clearXmlRpcGridContext);
            $('#btnXmlRpcSearch').click(_w.xmlrpcrequestlog.searchXmlRpcGrid);

		},

		exportXmlRpcGrid : function()
		{
			App.API.execTask(
					'gridSystemXmlRpcRequest', {}, {'ExportToExcel': true},
					_w.xmlrpcrequestlog._onExportReceived, _w.taskExecError,
					'EXPORT', true
					);
		},

		initGrids : function()
		{

			_w.xmlrpcrequestlog.ti.hydrate({
				// XmlRpc grid
				'gridXmlRpcTitle': 'View xml-rpc request logs',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						/*Export: {
							preset: 'GridExport',
							id: 'exportAuctionGrid',
							handler: _w.xmlrpcrequestlog.exportXmlRpcGrid
						}*/
					}
				},
				'gridXmlRpcColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						ClientName: {
							id: 'gridXmlRpcColumn_ClientName',
							title: 'CLIENT NAME',
							orderAsc: {
								id: 'gridXmlRpcOrder_ClientNameAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcClient.clientName', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ClientNameDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcClient.clientName', 'DESC')
							}
						},
						ValuationNumber: {
							id: 'gridXmlRpcColumn_ValuationNumber',
							title: 'VALUATION NUMBER',
							orderAsc: {
								id: 'gridXmlRpcOrder_ValuationNumberAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'valuation.valuationNumber', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ValuationNumberDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'valuation.valuationNumber', 'DESC')
							}
						},
						ClientApiId: {
							id: 'gridXmlRpcColumn_ClientApiId',
							title: 'API ID',
							orderAsc: {
								id: 'gridXmlRpcOrder_ClientApiIdAsc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpcRequestLog.clientApiId', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_ClientApiIdDesc',
								bind: $.proxy(_w.xmlrpcclients.orderXmlRpcGrid, this, 'xmlRpcRequestLog.clientApiId', 'DESC')
							}
						},
						IpAddress: {
							id: 'gridXmlRpcColumn_IpAddress',
							title: 'IP ADDRESS',
							orderAsc: {
								id: 'gridXmlRpcOrder_IpAddressAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.ipAddress', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_IpAddressDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.ipAddress', 'DESC')
							}
						},
						MethodName: {
							id: 'gridXmlRpcColumn_MethodName',
							title: 'METHOD',
							orderAsc: {
								id: 'gridXmlRpcOrder_MethodNameAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.methodName', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_MethodNameDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.methodName', 'DESC')
							}
						},
						Created: {
							id: 'gridXmlRpcColumn_Created',
							title: 'CREATED',
							orderAsc: {
								id: 'gridXmlRpcOrder_CreatedAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.created', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_CreatedDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.created', 'DESC')
							}
						},
						Status: {
							id: 'gridXmlRpcColumn_Status',
							title: 'STATUS',
							orderAsc: {
								id: 'gridXmlRpcOrder_StatusAsc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.status', 'ASC')
							},
							orderDesc: {
								id: 'gridXmlRpcOrder_StatusDesc',
								bind: $.proxy(_w.xmlrpcrequestlog.orderXmlRpcGrid, this, 'xmlRpcRequestLog.status', 'DESC')
							}
						}
					}
				},
				'gridXmlRpcColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						ClientName : {
							id: 'gridXmlRpcFilter_ClientName',
							context: 'gridXmlRpcFilter'
						},
						ValuationNumber : {
							id: 'gridXmlRpcFilter_ValuationNumber',
							context: 'gridXmlRpcFilter'
						},
						ClientApiId : {
							id: 'gridXmlRpcFilter_ClientApiId',
							context: 'gridXmlRpcFilter'
						},
						IpAddress : {
							id: 'gridXmlRpcFilter_IpAddress',
							context: 'gridXmlRpcFilter'
						},
						MethodName: {
							id: 'gridXmlRpcFilter_MethodName',
							context: 'gridXmlRpcFilter'
						},
						Created: {
							id: 'gridXmlRpcFilter_Created',
							context: 'gridXmlRpcFilter'
						},
						Status: {
							id: 'gridXmlRpcFilter_Status',
							context: 'gridXmlRpcFilter'
						}
					}
				},
				'gridXmlRpcRowRepeater': {},
				'gridXmlRpcPager': {}
			});

		},

		loadXmlRpcGrid : function( contract, data, options )
		{
			App.API.execTask(
					'gridSystemXmlRpcRequest', data, options,
					_w.xmlrpcrequestlog._onXmlRpcGridDataReceived, _w.taskExecError
					);
		},

		pageXmlRpcGrid : function( page )
		{
			_w.xmlrpcrequestlog.loadXmlRpcGrid( {}, {"Grid":{"Page":page}} );
		},

		clearXmlRpcGridContext : function()
		{
			$('.gridXmlRpcContext').val('');
			$('.gridXmlRpcFilter').val('');
			_w.xmlrpcrequestlog.searchXmlRpcGrid();
		},

		searchXmlRpcGrid : function()
		{
			var filter = {
					count: 0,
					filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ClientName', 'xmlRpcClient.clientName');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ValuationNumber', 'valuation.valuationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_ClientApiId', 'xmlRpcRequestLog.clientApiId');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_IpAddress', 'xmlRpcRequestLog.ipAddress');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_MethodName', 'xmlRpcRequestLog.methodName');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Created', 'xmlRpcRequestLog.created');
			filter = _w.filterIfnotEmpty(filter, 'gridXmlRpcFilter_Status', 'xmlRpcRequestLog.status');
			var request = {"Grid":{
			    "Page": 1,
			    "Filter": filter.filters
			  }};
			_w.xmlrpcrequestlog.loadXmlRpcGrid( null, request, {} );
		},

		_onXmlRpcGridDataReceived : function( response )
		{
			_w.xmlrpcrequestlog.ti.hydrateParam('gridXmlRpcRowRepeater', {});
			_w.populateFilters(response.Data.Meta.Filters, {
				'xmlRpcClient.clientName' 				: 'gridXmlRpcFilter_ClientName',
				'valuation.valuationNumber' 			: 'gridXmlRpcFilter_ValuationNumber',
				'xmlRpcRequestLog.clientApiId' 			: 'gridXmlRpcFilter_ClientApiId',
				'xmlRpcRequestLog.ipAddress' 			: 'gridXmlRpcFilter_IpAddress',
				'xmlRpcRequestLog.methodName' 			: 'gridXmlRpcFilter_MethodName',
				'xmlRpcRequestLog.created'				: 'gridXmlRpcFilter_Created',
				'xmlRpcRequestLog.status'				: 'gridXmlRpcFilter_Status'
			});
			_w.xmlrpcrequestlog.packetData = {};
			var gridData = [];
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				var row = response.Data.DataSet[i];
				_w.xmlrpcrequestlog.packetData['row' + row.id] = row.packet;
				gridData.push({
					rowId: row.id,
					bind: function(meta) {
						$('#row' +  meta.rowId).click(function(e){
							var id = $(this).attr('id');
							var jspr = JSON.stringify(_w.xmlrpcrequestlog.packetData[id], undefined, 2);
							jspr = jspr.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
							jspr = jspr.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
						        var cls = 'number';
						        if (/^"/.test(match)) {
						            if (/:$/.test(match)) {
						                cls = 'key';
						            } else {
						                cls = 'string';
						            }
						        } else if (/true|false/.test(match)) {
						            cls = 'boolean';
						        } else if (/null/.test(match)) {
						            cls = 'null';
						        }
						        return '<span class="' + cls + '">' + match + '</span>';
						    });
							$('#modalbody').html('<pre>' + jspr + '</pre>');
							$('#myModal').modal('toggle');
						});
					},
					prepend: {},
					style: {},
					items: {
						'id'         			: row.id,
						'ClientName' 			: row.xmlRpcClient.clientName,
						'ValuationNumber'		: row.valuation.valuationNumber,
						'ClientApiId'			: row.clientApiId,
						'IpAddress'				: row.ipAddress,
						'MethodName'			: row.methodName,
						'Created'				: row.created,
						'Status'				: row.status
				}
				});
			}
			_w.xmlrpcrequestlog.ti.hydrateParam('gridXmlRpcRowRepeater', {
				constructor : 'GridDataRow',
				items       : gridData
			});
			response.Data.Meta.itemName = 'userPager';
			response.Data.Meta.bind = _w.xmlrpcrequestlog.pageXmlRpcGrid;
			_w.xmlrpcrequestlog.ti.hydrateParam('gridXmlRpcPager', {
				constructor : 'GridPager',
				items       : [response.Data.Meta]
			});
		},

		orderXmlRpcGrid : function(field, direction)
		{
			var order = {};
			order[field] = direction;
			_w.xmlrpcrequestlog.loadXmlRpcGrid( {}, {"Grid":{"Page": 1, "OrderBy": order}} );
		},

		_onExportReceived : function( response )
		{
			var win = window.open();
			win.document.write(response);
		}

	};

})();