;(function(){

 	window._w.historyview = {

 		itemId        : null,
 		itemData      : null,
 		formMeta      : null,
 		basketId      : null,
 		basketData    : null,
 		bidId         : null,
 		bidData       : null,
 		ti            : null,
 		limited       : false,
 		newItem       : false,
 		nextBid       : false,
 		bidType       : null,

 		onHistoryViewTemplateReady : function( template, event, eventData )
 		{
 			console.log('onHistoryViewTemplateReady');
 			_w.historyview.ti = _t[template];
 			_w.historyview.limited = ('limitedhistoryview' == template)
 				? true
 				: false;

 			_w.historyview.setStockViewFormMeta();
 			_w.historyview.ti.hydrate(_w.historyview.formMeta);

 			// Retrieve initial view data.
 			
 			_w.historyview.itemId   = App.Util.getUrlParam('id');
 			_w.historyview.bidId    = null;
 			
 			// Stock data
 			var task = 'Auction.View';
 			App.API.getTask(
 				'viewAuction:' + _w.historyview.itemId, 'Auction', task, _w.historyview.itemId,
 				{}, $.proxy( _w.historyview._onStockViewDataReceived, this ), _w.taskContractError
 			);
 		},

 		onHistoryViewPublished : function( template, event, eventData )
 		{
 			console.log('onHistoryViewPublished');
 			if (!_w.historyview.basketId)
 			{
 				$('#btnAddToBasket').prop('disabled', false);
 				$('#btnAddToBasket').removeClass('addtobasketbtntrue');
 				$('#btnAddToBasket').addClass('addtobasketbtn');
 			}


 			$('#btnRequestHPI').click(function () {

				if ('' == $('#HPIusername').val() || '' ==  $('#HPIpin').val())
				{
					alert('Please enter a valid username and password.');
					return;
				}

				$('#HPIdropConfirm').slideToggle();
				$('#HPIresponse').html('');
			});


			App.Util.updateCheckboxStyle($('#acceptHPIdisclaimer'));
 			$('#HPIbtnConfirm').click(function () {
				if ( $('#engineNumber').html() == '' || $('#vinNumber').html() == '' ) {
					alert('Cannot request report without Vehicle Engine Number and VIN Number.');
					return;
				}
				if (!$('#acceptHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}

				var user = $('#HPIusername').val();
				var pass = $('#HPIpin').val();

				App.API.getTask(
						'TransUnionForHPI', 'Stock', 'Utility.TransUnionForHPI', null,
						{'Filter' : {'username' : user ,'pass' : pass , 'stock' : _w.stock.Id}},
						function() {
							App.API.execTask(
									'TransUnionForHPI',{}, {},
									function(data)
									{
										$('#HPIdropConfirm').hide();
										if ('Success' == data.Status)
										{
											$('#HPIresponse').html('Success on HPI Report');
											alert('Success on HPI Report');
											App.DataStore.loadSelectListData(
													'tuhpi', false, 'Stock', 'Tuhpi.List', null,{"Filter":
													{
														"stock" 		: _w.historyview.itemData.stock.id,
														"company" 		: App.companyData.id
													}}, {},function() {
													// data is retrieved
													var tuHpiData = App.DataStore.getData('tuhpi');
													for (var i = 0; i < tuHpiData.length; i++)
													{
														var tuHpiId = tuHpiData[i].id
														var tuHpiCreated = tuHpiData[i].created
														if (tuHpiId)
														{
															$('#tuhpiDate').html(tuHpiCreated);
															$('#downloadTuhpi').show();
															$('#HPIbtnConfirm').prop('disabled', true);
															return;
														}
														else
														{
															$('#tuhpiDate').html('Not Requested Yet');
															$('#downloadTuhpi').hide();
															$('#HPIbtnConfirm').prop('disabled', false);
														}
													}
											});
										}
										else
										{
											$('#HPIresponse').html('API call to remote host failed. No data could be retrieved from remote service.');
										}
									}, function(response)
									{
										$('#HPIbtnConfirm').prop('disabled', false);
										alert(
											undefined != response.StatusReason
												? response.StatusReason
												: 'API call to remote host failed. No data could be retrieved from remote service.'
										);
									}
							);
						}


						, _w.taskContractError
				);
			});


 			$('#downloadTuhpi').click(function () {
				//console.log("stock id",  _w.stock.Id);
				App.API.getTask(
						'printTuhpi:' + _w.stock.Id, 'Stock', 'Tuhpi.Print', _w.stock.Id,
						{}, function() {
							App.API.execTask(
									'printTuhpi:' + _w.stock.Id, {}, {},
									function () {}, _w.taskExecError,
									'EXPORT', true
							);
						}, _w.taskContractError
				);
			});


 			$('#btnAddToBasket').click(function () {
 				$('#btnAddToBasket').prop('disabled', true);
 				if (_w.historyview.basketId)
 				{
 					App.API.execTask(
 							'updateBasket:' + _w.historyview.itemId, {Basket:{archived: false}}, {},
 							function() {
 								alert('Item added to basket.');
 								$('#btnAddToBasket').removeClass('addtobasketbtn');
 				 				$('#btnAddToBasket').addClass('addtobasketbtntrue');
 							}, _w.taskExecError
 						);
 				}
 				else
 				{
 					App.API.execTask(
 							'createBasket:' + _w.historyview.itemId, {Basket:{auction:_w.historyview.itemId}}, {},
 							function() {
 								alert('Item added to basket.');
 								$('#btnAddToBasket').removeClass('addtobasketbtn');
 				 				$('#btnAddToBasket').addClass('addtobasketbtntrue');
 							}, _w.taskExecError
 						);
 				}
 			});
 			$('#btnMakeBid').click(function () {
 				$('#confirm_dynamic').show();
 				$('#confirmation_msg').hide();
 				_w.historyview.ti.hydrateParam('infAmount', _w.historyview.nextBid);
 				$('#dropCmp').hide();
 				$('#dropConfirm').show();
 				_w.historyview.bidType = 'bid';
 			});
 			$('#btnAskQuestion').click(function () {
 				if ('' == $('#question').val())
 				{
 					alert('Please specify your question.');
 					return;
 				}
 				App.API.getTask(
 						'askQuestion:' + _w.historyview.itemId, 'Auction', 'Question.Create', _w.historyview.itemId,
 						{}, function() {
 							var data = {
 									"Question": {
 										"auction": _w.historyview.itemId,
 										"question": $('#question').val()
 									}
 							};
 							App.API.execTask(
 									'askQuestion:' + _w.historyview.itemId, data, {},
 									_w.historyview._onBidUpdated, function () {
 										alert('Your question have been submitted.');
 										$('#dropCmp3').slideToggle();
 									}
 								);
 						}, _w.taskContractError
 					);
 			});
 			$('#btnMakeAutoBid').click(function () {
 				$('#confirm_dynamic').show();
 				$('#confirmation_msg').hide();
 				var amount = $('#autoamount').val();
				if ('' != amount && isNaN(amount))
				{
					alert('Please enter a numeric value.');
					return;
				}
 				if ('' == amount)
 				{
 					_w.historyview.ti.hydrateParam('infAmount', _w.historyview.nextBid);
 					$('#dropCmp').hide();
 					$('#dropConfirm').show();
 					_w.historyview.bidType = 'bid';
 				}
 				else
 				{
 					var parts = amount.split('.');
 					if (parts.length > 1)
 					{
 						amount = parts[0];
 						$('#autoamount').val(amount);
 					}
 					if (amount < _w.historyview.nextBid)
 					{
 						$('#dropConfirm').show();
 						$('#confirm_dynamic').hide();
 						$('#confirmation_msg').show();
 						$('#confirmation_msg').html('Autobid amount must be more than R ' + _w.historyview.nextBid);
 						return;
 					}
 					_w.historyview.ti.hydrateParam('infAmount', amount);

 					$('#dropConfirm').show();
 					_w.historyview.bidType = 'autobid';
 				}
 			});

 			$('#btnConfirm').click(function () {
 				if ('bid' == _w.historyview.bidType)
 				{
 					var data = {
 							"Bid": {
 								"amount": _w.historyview.nextBid
 							}
 					};
 					App.API.execTask(
 							'createBid', data, {},
 							_w.historyview._onBidUpdated, function (response) {
 								$('#bidSection').hide();
 								console.log(response);
 								if (response.StatusReason && 'Your' == response.StatusReason.substring(0,4))
 								{
 									alert(response.StatusReason);
 								}
 								else
 								{
 									alert('Your bid was placed but you were just outbid. You can make another bid.');
 								}
 								App.API.getTask(
 										'viewAuction:' + _w.historyview.itemId, 'Auction', 'Auction.View', _w.historyview.itemId,
 										{}, $.proxy( _w.historyview._onStockViewDataReceived, this ), _w.taskContractError
 									);
 							}
 						);
 				}
 				else
 				{
 					var data = {
 							"AutoBid": {
 								"amount": $('#autoamount').val()
 							}
 					};
 					App.API.execTask(
 							'createAutoBid', data, {},
 							_w.historyview._onBidUpdated, function (response) {
 								console.log(response);
 								if (response.StatusReason && 'Your' == response.StatusReason.substring(0,4))
 								{
 									alert(response.StatusReason);
 								}
 								else
 								{
 									alert('Your bid was placed but you were just outbid. You can make another bid.');
 								}
 								App.API.getTask(
 										'viewAuction:' + _w.historyview.itemId, 'Auction', 'Auction.View', _w.historyview.itemId,
 										{}, $.proxy( _w.historyview._onStockViewDataReceived, this ), _w.taskContractError
 									);
 							}
 						);
 				}
 			});

 			App.Util.updateCheckboxStyle($('#terms_accepted'));
 			App.Util.updateCheckboxStyle($('#terms_accepted2'));
 			$('.showTerms').hover(
 				function() {
 					$('.moreTerms').show();
 				},
 				function() {
 				  	$('.moreTerms').hide();
 				}
 			);
 			$('#terms_accepted').click(function() {
 				$('#btnMakeBid').prop('disabled', $(this).prop('checked') ? false : true);
 			});
 			$('#terms_accepted2').click(function() {
 				$('#btnMakeAutoBid').prop('disabled', $(this).prop('checked') ? false : true);
 			});

 			$('.mobile-header-bottom .bottom-heading').text('BID DETAILS');

 			if (null != _w.historyview.itemData)
 			{
 				_w.historyview._onStockDataAndTemplate();
 			}
 			if (null != _w.historyview.basketData)
 			{
 				_w.historyview._onBasketDataAndTemplate();
 			}


 		},

 		setStockViewFormMeta : function( data )
 		{
 			data = (undefined == data)
 				? {"stock":{}}
 				: data;



 			_w.stock.Id = data.stock.id;

 			var damagesHtml = '';
 			var accessoriesHtml = '';
 			if (undefined != data && undefined != data.stock && undefined != data.stock.damages)
 			{
 				for (var i = 0; i < data.stock.damages.length; i++)
 				{
 					damagesHtml += '<div class="control-group row' + i + '">';
					damagesHtml += '<label class="control-label bid-information-label">' + data.stock.damages[i].damage.name + ':</label>';
 					damagesHtml += '<div class="controls">';
					damagesHtml += '<p class="bid-information">R ' + data.stock.damages[i].amount + '</p>';
 					damagesHtml += '</div>';
 					damagesHtml += '</div>';
 				}
 			}
 			if (undefined != data && undefined != data.stock && undefined != data.stock.accessories)
 			{
 				for (var i = 0; i < data.stock.accessories.length; i+=2)
 				{
 					var acc1 = data.stock.accessories[i]
 						? data.stock.accessories[i].accessory.name
 						: '&nbsp;';
 					var acc2 = data.stock.accessories[i+1]
 						? data.stock.accessories[i+1].accessory.name
 						: '&nbsp;';
 					accessoriesHtml += '<div class="row-fluid">';
					accessoriesHtml += '<div class="span6 textshow-black">' + acc1 + '</div>';
					accessoriesHtml += '<div class="span6 textshow-black">' + acc2 + '</div>';
					accessoriesHtml += '</div>';
				}
			}




			if (data.currentBidPrice)
			{
				_w.historyview.nextBid = 0.0 == data.currentBidPrice
					? parseFloat(data.reservePrice) + parseFloat(data.bidIncrement)
					: parseFloat(data.currentBidPrice) + parseFloat(data.bidIncrement);
			}
			else
			{
				_w.historyview.nextBid = 0.0;
			}
			_w.historyview.formMeta = {
				'auctionId' : data.id ? '<div class="row-fluid"><div class="span12"><b>Auction ID: </b>  ' + data.id + '</div></div>' : '',
				'b4cRefNo' : data.stock.referenceNumber ? '<div class="row-fluid"><div class="span12"><b>B4C reference no. ref# </b>  ' + data.stock.referenceNumber + '</div></div>' : '',
				'mmCode' : data.stock.type ? '<div class="row-fluid"><div class="span12"><b>M & M Code: </b>  ' + data.stock.type.mmCode + '</div></div>' : '',
				'vehicle' : data.stock.type
					? '<div class="row-fluid"><div class="span3"><h5><b>Vehicle Details:</b></h5></div><div class="span9"><h5>'
 							+ data.stock.vehicleYear.name + ', '
 							+ data.stock.type.category.name + ', '
 							+ data.stock.type.model.make.name + ', '
 							+ data.stock.type.model.name + ', '
							+ data.stock.type.name +  '</h5></div>'
 					: '',

 				'seller' : data.stock.type
					? '<div class="row-fluid"><div class="span4"><h5><b>Seller Details:</b></h5></div><div class="span8"><h5>'
 							+ data.company.contact.firstName + ' ' + data.company.contact.familyName + ', '
							+ data.company.contact.mobile + ', ' + data.company.name + '<br/>'
							+ data.company.street + ', '
							+ data.company.city.name + ', ' + data.company.region.name + ', '
							+ data.company.postalCode + '</h5></div>'
 					: '',
 				'vehicleYear' : {
 					title       : 'Year',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.vehicleYear ? data.stock.vehicleYear.name : ''
 				},
 				'category' : {
 					title       : 'Category',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.type ? data.stock.type.category.name : ''
 				},
 				'make' : {
 					title       : 'Vehicle Make',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.type ? data.stock.type.model.make.name : ''
 				},
 				'model' : {
 					id          : 'vehicleModel',
 					title       : 'Vehicle Model',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.type ? data.stock.type.model.name : ''
 				},
 				'type' : {
 					title       : 'Vehicle Type',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.type ? data.stock.type.name : ''
 				},
 				'fuelType' : {
 					title       : 'Fuel Type',
					value       : data.stock.fuelType ? data.stock.fuelType.name : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},

 				'transmissionType' : {
 					title       : 'Transmission Type',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.transmissionType ? data.stock.transmissionType.name : ''
 				},
 				'condition' : {
 					title       : 'Condition',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.condition ? data.stock.condition.name : ''
 				},
 				'exteriorColour' : {
 					title       : 'Main ext. colour',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.exteriorColour ? data.stock.exteriorColour.name : ''
 				},
 				'interiorColour' : {
 					title : 'Main int. colour',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value : data.stock.interiorColour ? data.stock.interiorColour.name : ''
 				},
 				'upholstery' : {
 					title       : 'Upholstery',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.upholstery ? data.stock.upholstery.name : ''
 				},
 				'papers' : {
 					title       : 'Papers',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.papers ? data.stock.papers.name : ''
 				},
 				'natis' : {
 					title       : 'Natis',
					value       : data.stock.natis ? data.stock.natis.name : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'spareKeys' : {
 					title       : 'Spare keys',
 					value       : undefined == data.stock.spareKeys
 									? ''
									: (data.stock.spareKeys ? 'Yes' : 'No'),
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'fullServiceHistory' : {
 					title       : 'Full service history',
 					value       : undefined == data.stock.fullServiceHistory
 									? ''
									: data.stock.fullServiceHistory.name,
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'registrationNumber' : {
 					title : 'Registration no',
					value : data.stock.registrationNumber ? data.stock.registrationNumber : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'vinNumber' : {
 					title : 'Vin no',
					value : data.stock.vinNumber ? data.stock.vinNumber : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'engineNumber' : {
 					title : 'Engine no',
					value : data.stock.engineNumber ? data.stock.engineNumber : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'km' : {
 					title : 'Kms',
					value : data.stock.km ? data.stock.km : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'fshNotes' : {
 					title : 'FSH notes',
 					value : data.stock.fshNotes ? data.stock.fshNotes : ''
 				},
 				'fshNotes_title' : {
 					title : 'FSH notes',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'fshNotes_data' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value : data.stock.fshNotes ? data.stock.fshNotes : ''
 				},
 				'damages' : damagesHtml,
 				'damageTotal' : {
 					title : 'Total estimated repair price',
					value : 'R ' + (data.stock ? data.stock.damageTotal : '0.00'),
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'damageNotes' : {
 					title : 'Damages comments',
					value : data.stock.damageNotes ? data.stock.damageNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'damageNotes_title' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					title : 'Damages comments',
					value: ''
 				},
 				'damageNotes_data' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value : data.stock.damageNotes ? data.stock.damageNotes : ''
 				},
 				'previousRepairsNoted' : {
 					title : 'Previous repairs noted',
					value : data.stock.previousRepairsNoted ? 'Yes' : 'No',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'previousRepairsNotes' : {
 					title : 'Previous repairs comments',
					value : data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'previousRepairsNotes_title' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					title : 'Previous repairs comments',
 				},
 				'previousRepairsNotes_data' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value : data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : ''
 				},

 				'accessories' : accessoriesHtml,


 				'accessoryNew' : {
 					value       : data.stock.accessoryNotes ? data.stock.accessoryNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label hidden'
 				},


 				'accessoryNotes' : {
 					title     	: 'Comments',
					value     	: data.stock.accessoryNotes ? data.stock.accessoryNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'accessoryNotes_title' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					title     : 'Accessories Comments',
					value: ''
 				},
 				'accessoryNotes_data' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					value       : data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
 				},



 				'accessoriesMobi' : accessoriesHtml,
 				'accessoryNotesMobi' : {
 					title     	: 'Comments',
					value     	: data.stock.accessoryNotes ? data.stock.accessoryNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'accessoryNotes_titleMobi' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					title     	: 'Accessories Comments',
					value		: ''
 				},
 				'accessoryNotes_dataMobi' : {
					style       : 'bid-information',
					labelStyle  : 'bid-information-label',
 					title     	: 'Accessories Notes',
 					value     	: data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
 				},

 				'accessoryNewMobi' : {
 					value       : data.stock.accessoryNotes ? data.stock.accessoryNotes : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},



				'bidImgMain' : {
					type  : 'bidMainImage',
					view  : true,
					id    : 'bidImgMain',
					baseImage : 'main_img_car.jpg',
					value : data.stock.mainImage ? data.stock.mainImage : ''
				},
 				'mainImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'mainImage',
 					baseImage : 'main_img_car.jpg',
 					value : data.stock.mainImage ? data.stock.mainImage : ''
 				},
 				'frontImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'frontImage',
 					baseImage : 'front_car.jpg',
 					value : data.stock.frontImage ? data.stock.frontImage : ''
 				},
 				'leftImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'leftImage',
 					baseImage : 'left_car.jpg',
 					value : data.stock.leftImage ? data.stock.leftImage : ''
 				},
 				'rightImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'rightImage',
 					baseImage : 'right_car.jpg',
 					value : data.stock.rightImage ? data.stock.rightImage : ''
 				},
 				'backImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'backImage',
 					baseImage : 'back_car.jpg',
 					value : data.stock.backImage ? data.stock.backImage : ''
 				},
 				'interiorImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'interiorImage',
 					baseImage : 'interior_car.jpg',
 					value : data.stock.interiorImage ? data.stock.interiorImage : ''
 				},
 				'engineImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'engineImage',
 					baseImage : 'engine_car.jpg',
 					value : data.stock.engineImage ? data.stock.engineImage : ''
 				},
 				'natisImage' : {
					type  : 'bidimage',
 					view  : true,
 					id    : 'natisImage',
 					baseImage : 'copy_of_natis_car.jpg',
 					value : data.stock.natisImage ? data.stock.natisImage : ''
 				},

 				'infCreated': data.created ? ((data.created).split(' '))[0] : '',
 				'infLoadedOnAuction': data.stock.loadedOnAuction
 					? ((data.stock.loadedOnAuction).split(' '))[0] : '',
 				'infTradePrice': {
 					title : '<b>Trade</b>',
					value : data.stock.tradePrice ? '&nbsp;&nbsp;R ' + data.stock.tradePrice : '&nbsp;&nbsp;R 0.00',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'infRetailPrice': {
 					title : '<b>Retail</b>',
					value : data.stock.retailPrice ? '&nbsp;&nbsp;R ' + data.stock.retailPrice : '&nbsp;&nbsp;0.00',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
                'infListPrice': {
                    title : '<b>New list price</b>',
                    value : data.stock.listPrice ? '&nbsp;&nbsp;R ' + data.stock.listPrice : '&nbsp;&nbsp;R 0.00',
                    style       : 'bid-information',
                    labelStyle  : 'bid-information-label'
                },

 				'companyName' : {
 					title : 'Dealership name',
					value : data.company ? data.company.name : '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'companyContact' : {
 					title : 'Name and surname',
 					value : data.company && data.company.contact
 								? data.company.contact.firstName + ' ' + data.company.contact.familyName
								: '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'companyMobile' : {
 					title : 'Mobile',
 					value : data.company && data.company.contact
 								? data.company.contact.mobile
								: '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'companyEmail' : {
 					title : 'Email',
 					value : data.company && data.company.contact
 								? data.company.contact.email
								: '',
					style       : 'bid-information',
					labelStyle  : 'bid-information-label'
 				},
 				'amount' : {
 					type  : 'input',
 					id    : 'amount',
 					title : 'Amount',
 					value : _w.historyview.nextBid,
 					disabled: true
 				},
 				'autoamount' : {
					type  : 'amountAuction',
 					id    : 'autoamount',
 					title : '',
 					value : '' //parseFloat(_w.historyview.nextBid) + parseFloat(data.bidIncrement)
 				},
 				'question' : {
 					type  : 'textarea-styled',
 					id    : 'question',
 					title : 'Question',
 					value : '',
 					style : 'span12',
 					areaStyle: 'span12'
 				},
 				'infAmount' : _w.historyview.nextBid,
				'myAutoBid' : data.currentBid && data.currentBid.autoBid
 								&& App.companyData.id == data.currentBid.autoBid.company
								? '<b>My auto-bid:<br/>R ' + data.currentBid.autoBid.amount + '</b>'
								: '<b>No current auto-bid.</b>',
 				'nextBid' : {
 					title : 'Next bid',
 					value : '<b>R ' + _w.historyview.nextBid + '</b>'
 				},
 				'nextBid_title' : {
 					title : 'Next bid',
 				},
 				'nextBid_data' : {
					value : '<b>R ' + _w.historyview.nextBid + '</b>',
					style : 'text-large-auction'
 				},
 				'winningBid' : {
 					title : 'Winning bid',
 					value : data.currentBid ? '<b>R ' + data.currentBid.amount + '</b>' : '<b>R 0.00</b>'
 				},
 				'complaint' : {
 					type  : 'textarea-styled',
 					id    : 'complaint',
 					title : 'Complaint',
 					value : '',
 					areaStyle : 'span12',
 					style : 'span10'
 				},
 				'print': {
 					constructor: 'Button',
 					items: {
 						Export: {
 							preset: 'Print',
 							id: 'printAuctionPdf',
 							handler: _w.historyview.printAuctionPdf
 						}
 					}
 				}
 			};
 		},

 		printAuctionPdf : function()
 		{
 			App.API.getTask(
 					'printAuctionPdf:' + _w.historyview.itemId, 'Auction', 'Pdf.Print', _w.historyview.itemId,
 					{}, function() {
 						App.API.execTask(
 								'printAuctionPdf:' + _w.historyview.itemId, {}, {},
 								function() {}, function() {},
 								'EXPORT', true
 						);
 					}, _w.taskContractError
 			);
 		},

 		_onBidDataAndTemplate : function ()
 		{


 			if ('Archived' == _w.historyview.bidData.status)
 			{
 				true == App.permissions.pgUnArchive ? $('#btnUnarchive').show() : $('#btnUnarchive').hide();
 				$('#btnArchive').hide();
 				$('#optMakeBid').hide();
 			}
 			else
 			{
 				true == App.permissions.pgArchive ? $('#btnArchive').show() : $('#btnArchive').hide();
 				$('#btnUnarchive').hide();
 			}
 		},

 		_onBasketDataAndTemplate : function ()
 		{
 			if (true == _w.historyview.basketData.archived)
 			{
 				$('#btnAddToBasket').prop('disabled', false);
 				$('#btnAddToBasket').removeClass('addtobasketbtntrue');
	 			$('#btnAddToBasket').addClass('addtobasketbtn');
 			}
 			else
 			{
 				$('#btnAddToBasket').prop('disabled', true);
 				$('#btnAddToBasket').removeClass('addtobasketbtn');
	 			$('#btnAddToBasket').addClass('addtobasketbtntrue');
 			}
 		},

 		_onStockDataAndTemplate : function ()
 		{
			App.DataStore.loadSelectListData(
					'tuhpi', false, 'Stock', 'Tuhpi.List', null,{"Filter":
					{
						"stock" 		: _w.historyview.itemData.stock.id,
						"company" 		: App.companyData.id
					}}, {},function() {
					// data is retrieved
					var tuHpiData = App.DataStore.getData('tuhpi');
					for (var i = 0; i < tuHpiData.length; i++)
					{
						var tuHpiId = tuHpiData[i].id
						var tuHpiCreated = tuHpiData[i].created
						//created
						console.log("tuhpi data Created", tuHpiCreated);
						console.log("tuhpi data id", tuHpiId);
						if (tuHpiId)
						{
							console.log("tuhpi data Created", tuHpiCreated);
							console.log("tuhpi data id", tuHpiId);
							$('#tuhpiDate').html(tuHpiCreated);
							$('#downloadTuhpi').show();
						}
						else
						{
							console.log("tuhpi no data id");
							$('#tuhpiDate').html('Not Requested Yet');
							$('#downloadTuhpi').hide();
						}
					}
			});
 			$('#disputeSection').hide();

 			//if ('Sold' == _w.historyview.itemData.jobState && _w.historyview.itemData.soldToCompany.id == App.companyData.id)
 			if ('Sold' == _w.historyview.itemData.jobState)
 			{
 				$('#bidSection').hide();
 				$('#disputeSection').show();
 				$('#btnLogDispute').click(function() {
 					var comp = $('#complaint').val();
 					if ('' == comp)
 					{
 						alert('Please specify the complaint.');
 						return;
 					}
 					var data = {
 							Dispute : {
 								againstCompany : _w.historyview.itemData.company.id,
 								auction        : _w.historyview.itemId,
 								complaint      : comp
 							}
 					};
 					App.API.getTask(
 							'createDispute', 'Dispute', 'Dispute.Create',
 							null, {}, function(){
 								App.API.execTask(
 										'createDispute', data, {},
 										function() {
 											alert('Dispute logged.');
 											_w.historyview._onBidUpdated();
 										}, function() {}
 								);
 							}, _w.taskContractError
 						);
 				});
 			}
 			else if ('Active' != _w.historyview.itemData.jobState)
 			{
 				$('#optMakeBid').hide();
 			}
 			else
 			{
 	 			$('#autoamount').focus(function() {
 	 				$('#dropConfirm').hide();
 	 			});
 				App.API.getTask(
 						'createBid', 'Auction', 'Bid.Create',
 						_w.historyview.itemId, {}, function(){}, function(){}
 					);
 				App.API.getTask(
 						'createAutoBid', 'Auction', 'AutoBid.Create',
 						_w.historyview.itemId, {}, function(){}, function(){}
 				);
 			}

 			$("#tS1").thumbnailScroller({
 				/* scroller type based on mouse interaction
 				values: "hoverPrecise", "hoverAccelerate", "clickButtons"
 				default: "hoverPrecise" */
 				scrollerType:"hoverAccelerate",
 				/* scroller orientation
 				values: "horizontal", "vertical"
 				default: "horizontal" */
 				scrollerOrientation:"horizontal",
 				/* scroll easing type only for "hoverPrecise" scrollers
 				available values here: http://jqueryui.com/demos/effect/easing.html
 				default: "easeOutCirc" */
 				scrollEasing:"easeOutCirc",
 				/* scroll easing amount only for "hoverPrecise" and "clickButtons" scrollers (0 for no easing)
 				values: milliseconds
 				default: 800 */
 				scrollEasingAmount:300,
 				/* acceleration value only for "hoverAccelerate" scrollers
 				values: integer
 				default: 2 */
 				acceleration:0,
 				/* scrolling speed only for "clickButtons" scrollers
 				values: milliseconds
 				default: 600 */
 				scrollSpeed:100,
 				/* scroller null scrolling area only for "hoverAccelerate" scrollers
 				0 being the absolute center of the scroller
 				values: pixels
 				default: 0 */
 				noScrollCenterSpace:0,
 				/* initial auto-scrolling
 				0 equals no auto-scrolling
 				values: amount of auto-scrolling loops (integer)
 				default: 0 */
 				autoScrolling:1,
 				/* initial auto-scrolling speed
 				values: milliseconds
 				default: 8000 */
 				autoScrollingSpeed:100,
 				/* initial auto-scrolling easing type
 				available values here: http://jqueryui.com/demos/effect/easing.html
 				default: "easeInOutQuad" */
 				autoScrollingEasing:"easeInOutQuad",
 				/* initial auto-scrolling delay for each loop
 				values: milliseconds
 				default: 2500 */
 				autoScrollingDelay:250
 			});


 			/*
 			 * Permissions
 			 */
 			if (false == App.permissions.auctionBid)
 			{
 				$('#bidSection').hide();
 			}

 			if (App.permissions.settingsHpiReport == false)
			{
				$('#requestHPIreport').hide();
			}
 			else
 			{
				if (App.permissions.settingsHpiReport)
				{
					$('#requestHPIreport').show();
				}
 			}
 		},

 		_onBasketDataReceived : function( response )
 		{
 			_w.historyview.basketData = response.Data;
 			if (_w.historyview.ti.published)
 			{
 				_w.historyview._onBasketDataAndTemplate();
 			}
 		},

 		_onStockViewDataReceived : function( response )
 		{

 			console.log('response', response);
 			_w.historyview.itemId = response.Data.id;
 			_w.historyview.itemData = response.Data;
 			_w.historyview.setStockViewFormMeta(response.Data);
 			_w.historyview.ti.hydrate(_w.historyview.formMeta);
 			if (response.Data.currentBid)
 			{
 				_w.historyview.bidId = response.Data.currentBid.id;
 				_w.historyview.bidData = response.Data.currentBid;
 				if (_w.historyview.bidData.company.id != App.companyData.id)
 				{
 					$('#bidSection').show();
 					$('#winningBid').hide();
 				}
 				else
 				{
 					$('#bidSection').hide();
 					$('#winningBid').show();
 				}
 			}
 			else
 			{
 				$('#bidSection').show();
 				_w.historyview.newItem = true;
 				_w.historyview.bidData = {};
 			}
 			if (_w.historyview.itemData.company.id == App.companyData.id || _w.historyview.itemData.stock.company.id  == App.companyData.id)
 			{
 				$('#bidSection').hide();
 			}
 			if (_w.historyview.ti.published)
 			{
 				_w.historyview._onStockDataAndTemplate();
 			}
 		},

 		_onBidUpdated : function( response )
 		{
 			window.location.hash = '/auction';
 		}

 	};

 })();
